Index: palm/trunk/SOURCE/surface_data_output_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 4671)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+!
+! 4601 2020-07-14 12:06:09Z suehring
 ! Minor simplification in name creation for IO variables in restart files.
 !
@@ -372,6 +375,6 @@
 !
 !-- Determine the number of surface elements on subdomain
-    surfaces%ns = surf_def_h(0)%ns + surf_lsm_h%ns + surf_usm_h%ns           & !horizontal upward-facing
-                + surf_def_h(1)%ns                                           & !horizontal downard-facing
+    surfaces%ns = surf_def_h(0)%ns + surf_lsm_h(0)%ns + surf_usm_h(0)%ns     & !horizontal upward-facing
+                + surf_def_h(1)%ns + surf_lsm_h(1)%ns + surf_usm_h(1)%ns     & !horizontal downard-facing
                 + surf_def_v(0)%ns + surf_lsm_v(0)%ns + surf_usm_v(0)%ns     & !northward-facing
                 + surf_def_v(1)%ns + surf_lsm_v(1)%ns + surf_usm_v(1)%ns     & !southward-facing
@@ -474,48 +477,48 @@
              ENDIF
           ENDDO
-       ENDDO
-       DO  m = 1, surf_lsm_h%ns
-          i = surf_lsm_h%i(m) + surf_lsm_h%ioff
-          j = surf_lsm_h%j(m) + surf_lsm_h%joff
-          k = surf_lsm_h%k(m) + surf_lsm_h%koff
-
-          IF ( point_index(k,j,i) < 0 )  THEN
-             surfaces%npoints   = surfaces%npoints + 1
-             point_index(k,j,i) = surfaces%npoints - 1
-          ENDIF
-          IF ( point_index(k,j,i+1) < 0 )  THEN
-             surfaces%npoints     = surfaces%npoints + 1
-             point_index(k,j,i+1) = surfaces%npoints - 1
-          ENDIF
-          IF ( point_index(k,j+1,i+1) < 0 )  THEN
-             surfaces%npoints       = surfaces%npoints + 1
-             point_index(k,j+1,i+1) = surfaces%npoints - 1
-          ENDIF
-          IF ( point_index(k,j+1,i) < 0 )  THEN
-             surfaces%npoints     = surfaces%npoints + 1
-             point_index(k,j+1,i) = surfaces%npoints - 1
-          ENDIF
-       ENDDO
-       DO  m = 1, surf_usm_h%ns
-          i = surf_usm_h%i(m) + surf_usm_h%ioff
-          j = surf_usm_h%j(m) + surf_usm_h%joff
-          k = surf_usm_h%k(m) + surf_usm_h%koff
-
-          IF ( point_index(k,j,i) < 0 )  THEN
-             surfaces%npoints   = surfaces%npoints + 1
-             point_index(k,j,i) = surfaces%npoints - 1
-          ENDIF
-          IF ( point_index(k,j,i+1) < 0 )  THEN
-             surfaces%npoints     = surfaces%npoints + 1
-             point_index(k,j,i+1) = surfaces%npoints - 1
-          ENDIF
-          IF ( point_index(k,j+1,i+1) < 0 )  THEN
-             surfaces%npoints       = surfaces%npoints + 1
-             point_index(k,j+1,i+1) = surfaces%npoints - 1
-          ENDIF
-          IF ( point_index(k,j+1,i) < 0 )  THEN
-             surfaces%npoints     = surfaces%npoints + 1
-             point_index(k,j+1,i) = surfaces%npoints - 1
-          ENDIF
+          DO  m = 1, surf_lsm_h(l)%ns
+             i = surf_lsm_h(l)%i(m) + surf_lsm_h(l)%ioff
+             j = surf_lsm_h(l)%j(m) + surf_lsm_h(l)%joff
+             k = surf_lsm_h(l)%k(m) + surf_lsm_h(l)%koff
+
+             IF ( point_index(k,j,i) < 0 )  THEN
+                surfaces%npoints   = surfaces%npoints + 1
+                point_index(k,j,i) = surfaces%npoints - 1
+             ENDIF
+             IF ( point_index(k,j,i+1) < 0 )  THEN
+                surfaces%npoints     = surfaces%npoints + 1
+                point_index(k,j,i+1) = surfaces%npoints - 1
+             ENDIF
+             IF ( point_index(k,j+1,i+1) < 0 )  THEN
+                surfaces%npoints       = surfaces%npoints + 1
+                point_index(k,j+1,i+1) = surfaces%npoints - 1
+             ENDIF
+             IF ( point_index(k,j+1,i) < 0 )  THEN
+                surfaces%npoints     = surfaces%npoints + 1
+                point_index(k,j+1,i) = surfaces%npoints - 1
+             ENDIF
+          ENDDO
+          DO  m = 1, surf_usm_h(l)%ns
+             i = surf_usm_h(l)%i(m) + surf_usm_h(l)%ioff
+             j = surf_usm_h(l)%j(m) + surf_usm_h(l)%joff
+             k = surf_usm_h(l)%k(m) + surf_usm_h(l)%koff
+
+             IF ( point_index(k,j,i) < 0 )  THEN
+                surfaces%npoints   = surfaces%npoints + 1
+                point_index(k,j,i) = surfaces%npoints - 1
+             ENDIF
+             IF ( point_index(k,j,i+1) < 0 )  THEN
+                surfaces%npoints     = surfaces%npoints + 1
+                point_index(k,j,i+1) = surfaces%npoints - 1
+             ENDIF
+             IF ( point_index(k,j+1,i+1) < 0 )  THEN
+                surfaces%npoints       = surfaces%npoints + 1
+                point_index(k,j+1,i+1) = surfaces%npoints - 1
+             ENDIF
+             IF ( point_index(k,j+1,i) < 0 )  THEN
+                surfaces%npoints     = surfaces%npoints + 1
+                point_index(k,j+1,i) = surfaces%npoints - 1
+             ENDIF
+          ENDDO
        ENDDO
 !
@@ -731,94 +734,94 @@
              surfaces%polygons(5,npg)   = point_index(k,j+1,i)
           ENDDO
-       ENDDO
-       DO  m = 1, surf_lsm_h%ns
-          i = surf_lsm_h%i(m) + surf_lsm_h%ioff
-          j = surf_lsm_h%j(m) + surf_lsm_h%joff
-          k = surf_lsm_h%k(m) + surf_lsm_h%koff
-          IF ( point_index(k,j,i) < 0 )  THEN
-             surfaces%npoints   = surfaces%npoints + 1
-             point_index(k,j,i) = point_index_count
-             point_index_count  = point_index_count + 1
-             surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
-             surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
-             surfaces%points(3,surfaces%npoints) = zw(k)
-          ENDIF
-          IF ( point_index(k,j,i+1) < 0 )  THEN
-             surfaces%npoints     = surfaces%npoints + 1
-             point_index(k,j,i+1) = point_index_count
-             point_index_count    = point_index_count + 1
-             surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
-             surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
-             surfaces%points(3,surfaces%npoints) = zw(k)
-          ENDIF
-          IF ( point_index(k,j+1,i+1) < 0 )  THEN
-             surfaces%npoints       = surfaces%npoints + 1
-             point_index(k,j+1,i+1) = point_index_count
-             point_index_count      = point_index_count + 1
-             surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
-             surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
-             surfaces%points(3,surfaces%npoints) = zw(k)
-          ENDIF
-          IF ( point_index(k,j+1,i) < 0 )  THEN
-             surfaces%npoints     = surfaces%npoints + 1
-             point_index(k,j+1,i) = point_index_count
-             point_index_count    = point_index_count + 1
-             surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
-             surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
-             surfaces%points(3,surfaces%npoints) = zw(k)
-          ENDIF
-
-          npg                        = npg + 1
-          surfaces%polygons(1,npg)   = 4
-          surfaces%polygons(2,npg)   = point_index(k,j,i)
-          surfaces%polygons(3,npg)   = point_index(k,j,i+1)
-          surfaces%polygons(4,npg)   = point_index(k,j+1,i+1)
-          surfaces%polygons(5,npg)   = point_index(k,j+1,i)
-       ENDDO
-
-       DO  m = 1, surf_usm_h%ns
-          i = surf_usm_h%i(m) + surf_usm_h%ioff
-          j = surf_usm_h%j(m) + surf_usm_h%joff
-          k = surf_usm_h%k(m) + surf_usm_h%koff
-
-          IF ( point_index(k,j,i) < 0 )  THEN
-             surfaces%npoints   = surfaces%npoints + 1
-             point_index(k,j,i) = point_index_count
-             point_index_count  = point_index_count + 1
-             surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
-             surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
-             surfaces%points(3,surfaces%npoints) = zw(k)
-          ENDIF
-          IF ( point_index(k,j,i+1) < 0 )  THEN
-             surfaces%npoints     = surfaces%npoints + 1
-             point_index(k,j,i+1) = point_index_count
-             point_index_count    = point_index_count + 1
-             surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
-             surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
-             surfaces%points(3,surfaces%npoints) = zw(k)
-          ENDIF
-          IF ( point_index(k,j+1,i+1) < 0 )  THEN
-             surfaces%npoints       = surfaces%npoints + 1
-             point_index(k,j+1,i+1) = point_index_count
-             point_index_count      = point_index_count + 1
-             surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
-             surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
-             surfaces%points(3,surfaces%npoints) = zw(k)
-          ENDIF
-          IF ( point_index(k,j+1,i) < 0 )  THEN
-             surfaces%npoints     = surfaces%npoints + 1
-             point_index(k,j+1,i) = point_index_count
-             point_index_count    = point_index_count + 1
-             surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
-             surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
-             surfaces%points(3,surfaces%npoints) = zw(k)
-          ENDIF
-
-          npg                        = npg + 1
-          surfaces%polygons(1,npg)   = 4
-          surfaces%polygons(2,npg)   = point_index(k,j,i)
-          surfaces%polygons(3,npg)   = point_index(k,j,i+1)
-          surfaces%polygons(4,npg)   = point_index(k,j+1,i+1)
-          surfaces%polygons(5,npg)   = point_index(k,j+1,i)
+          DO  m = 1, surf_lsm_h(l)%ns
+             i = surf_lsm_h(l)%i(m) + surf_lsm_h(l)%ioff
+             j = surf_lsm_h(l)%j(m) + surf_lsm_h(l)%joff
+             k = surf_lsm_h(l)%k(m) + surf_lsm_h(l)%koff
+             IF ( point_index(k,j,i) < 0 )  THEN
+                surfaces%npoints   = surfaces%npoints + 1
+                point_index(k,j,i) = point_index_count
+                point_index_count  = point_index_count + 1
+                surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
+                surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
+                surfaces%points(3,surfaces%npoints) = zw(k)
+             ENDIF
+             IF ( point_index(k,j,i+1) < 0 )  THEN
+                surfaces%npoints     = surfaces%npoints + 1
+                point_index(k,j,i+1) = point_index_count
+                point_index_count    = point_index_count + 1
+                surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
+                surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
+                surfaces%points(3,surfaces%npoints) = zw(k)
+             ENDIF
+             IF ( point_index(k,j+1,i+1) < 0 )  THEN
+                surfaces%npoints       = surfaces%npoints + 1
+                point_index(k,j+1,i+1) = point_index_count
+                point_index_count      = point_index_count + 1
+                surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
+                surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
+                surfaces%points(3,surfaces%npoints) = zw(k)
+             ENDIF
+             IF ( point_index(k,j+1,i) < 0 )  THEN
+                surfaces%npoints     = surfaces%npoints + 1
+                point_index(k,j+1,i) = point_index_count
+                point_index_count    = point_index_count + 1
+                surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
+                surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
+                surfaces%points(3,surfaces%npoints) = zw(k)
+             ENDIF
+
+             npg                        = npg + 1
+             surfaces%polygons(1,npg)   = 4
+             surfaces%polygons(2,npg)   = point_index(k,j,i)
+             surfaces%polygons(3,npg)   = point_index(k,j,i+1)
+             surfaces%polygons(4,npg)   = point_index(k,j+1,i+1)
+             surfaces%polygons(5,npg)   = point_index(k,j+1,i)
+          ENDDO
+
+          DO  m = 1, surf_usm_h(l)%ns
+             i = surf_usm_h(l)%i(m) + surf_usm_h(l)%ioff
+             j = surf_usm_h(l)%j(m) + surf_usm_h(l)%joff
+             k = surf_usm_h(l)%k(m) + surf_usm_h(l)%koff
+
+             IF ( point_index(k,j,i) < 0 )  THEN
+                surfaces%npoints   = surfaces%npoints + 1
+                point_index(k,j,i) = point_index_count
+                point_index_count  = point_index_count + 1
+                surfaces%points(1,surfaces%npoints) = ( i - 0.5_wp ) * dx
+                surfaces%points(2,surfaces%npoints) = ( j - 0.5_wp ) * dy
+                surfaces%points(3,surfaces%npoints) = zw(k)
+             ENDIF
+             IF ( point_index(k,j,i+1) < 0 )  THEN
+                surfaces%npoints     = surfaces%npoints + 1
+                point_index(k,j,i+1) = point_index_count
+                point_index_count    = point_index_count + 1
+                surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
+                surfaces%points(2,surfaces%npoints) = ( j     - 0.5_wp ) * dy
+                surfaces%points(3,surfaces%npoints) = zw(k)
+             ENDIF
+             IF ( point_index(k,j+1,i+1) < 0 )  THEN
+                surfaces%npoints       = surfaces%npoints + 1
+                point_index(k,j+1,i+1) = point_index_count
+                point_index_count      = point_index_count + 1
+                surfaces%points(1,surfaces%npoints) = ( i + 1 - 0.5_wp ) * dx
+                surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
+                surfaces%points(3,surfaces%npoints) = zw(k)
+             ENDIF
+             IF ( point_index(k,j+1,i) < 0 )  THEN
+                surfaces%npoints     = surfaces%npoints + 1
+                point_index(k,j+1,i) = point_index_count
+                point_index_count    = point_index_count + 1
+                surfaces%points(1,surfaces%npoints) = ( i     - 0.5_wp ) * dx
+                surfaces%points(2,surfaces%npoints) = ( j + 1 - 0.5_wp ) * dy
+                surfaces%points(3,surfaces%npoints) = zw(k)
+             ENDIF
+
+             npg                        = npg + 1
+             surfaces%polygons(1,npg)   = 4
+             surfaces%polygons(2,npg)   = point_index(k,j,i)
+             surfaces%polygons(3,npg)   = point_index(k,j,i+1)
+             surfaces%polygons(4,npg)   = point_index(k,j+1,i+1)
+             surfaces%polygons(5,npg)   = point_index(k,j+1,i)
+          ENDDO
        ENDDO
 
@@ -1119,43 +1122,35 @@
         i  = start_count
         mm = 1
-        DO  m = 1, surf_def_h(0)%ns
-           surfaces%s(mm)       = i
-           surfaces%xs(mm)      = ( surf_def_h(0)%i(m) + 0.5_wp ) * dx
-           surfaces%ys(mm)      = ( surf_def_h(0)%j(m) + 0.5_wp ) * dy
-           surfaces%zs(mm)      = zw(surf_def_h(0)%k(m)+surf_def_h(0)%koff)
-           surfaces%azimuth(mm) = surfaces%fillvalue
-           surfaces%zenith(mm)  = 0.0
-           i                    = i + 1
-           mm                   = mm + 1
-        ENDDO
-        DO  m = 1, surf_lsm_h%ns
-           surfaces%s(mm)       = i
-           surfaces%xs(mm)      = ( surf_lsm_h%i(m) + 0.5_wp ) * dx
-           surfaces%ys(mm)      = ( surf_lsm_h%j(m) + 0.5_wp ) * dy
-           surfaces%zs(mm)      = zw(surf_lsm_h%k(m)+surf_lsm_h%koff)
-           surfaces%azimuth(mm) = surfaces%fillvalue
-           surfaces%zenith(mm)  = 0.0
-           i                    = i + 1
-           mm                   = mm + 1
-        ENDDO
-        DO  m = 1, surf_usm_h%ns
-           surfaces%s(mm)       = i
-           surfaces%xs(mm)      = ( surf_usm_h%i(m) + 0.5_wp ) * dx
-           surfaces%ys(mm)      = ( surf_usm_h%j(m) + 0.5_wp ) * dy
-           surfaces%zs(mm)      = zw(surf_usm_h%k(m)+surf_usm_h%koff)
-           surfaces%azimuth(mm) = surfaces%fillvalue
-           surfaces%zenith(mm)  = 0.0
-           i                    = i + 1
-           mm                   = mm + 1
-        ENDDO
-        DO  m = 1, surf_def_h(1)%ns
-           surfaces%s(mm)       = i
-           surfaces%xs(mm)      = ( surf_def_h(1)%i(m) + 0.5_wp ) * dx
-           surfaces%ys(mm)      = ( surf_def_h(1)%j(m) + 0.5_wp ) * dy
-           surfaces%zs(mm)      = zw(surf_def_h(1)%k(m)+surf_def_h(1)%koff)
-           surfaces%azimuth(mm) = surfaces%fillvalue
-           surfaces%zenith(mm)  = 180.0
-           i                    = i + 1
-           mm                   = mm + 1
+        DO l = 0, 1
+           DO  m = 1, surf_def_h(l)%ns
+              surfaces%s(mm)       = i
+              surfaces%xs(mm)      = ( surf_def_h(l)%i(m) + 0.5_wp ) * dx
+              surfaces%ys(mm)      = ( surf_def_h(l)%j(m) + 0.5_wp ) * dy
+              surfaces%zs(mm)      = zw(surf_def_h(l)%k(m)+surf_def_h(l)%koff)
+              surfaces%azimuth(mm) = surfaces%fillvalue
+              surfaces%zenith(mm)  = 180.0_wp * l
+              i                    = i + 1
+              mm                   = mm + 1
+           ENDDO
+           DO  m = 1, surf_lsm_h(l)%ns
+              surfaces%s(mm)       = i
+              surfaces%xs(mm)      = ( surf_lsm_h(l)%i(m) + 0.5_wp ) * dx
+              surfaces%ys(mm)      = ( surf_lsm_h(l)%j(m) + 0.5_wp ) * dy
+              surfaces%zs(mm)      = zw(surf_lsm_h(l)%k(m)+surf_lsm_h(l)%koff)
+              surfaces%azimuth(mm) = surfaces%fillvalue
+              surfaces%zenith(mm)  = 180.0_wp * l
+              i                    = i + 1
+              mm                   = mm + 1
+           ENDDO
+           DO  m = 1, surf_usm_h(l)%ns
+              surfaces%s(mm)       = i
+              surfaces%xs(mm)      = ( surf_usm_h(l)%i(m) + 0.5_wp ) * dx
+              surfaces%ys(mm)      = ( surf_usm_h(l)%j(m) + 0.5_wp ) * dy
+              surfaces%zs(mm)      = zw(surf_usm_h(l)%k(m)+surf_usm_h(l)%koff)
+              surfaces%azimuth(mm) = surfaces%fillvalue
+              surfaces%zenith(mm)  = 180.0_wp * l
+              i                    = i + 1
+              mm                   = mm + 1
+           ENDDO
         ENDDO
 !
@@ -1528,12 +1523,11 @@
 !--          Output of instantaneous data
              IF ( av == 0 )  THEN
-                CALL surface_data_output_collect( surf_def_h(0)%us, surf_def_h(1)%us,              &
-                                                  surf_lsm_h%us, surf_usm_h%us, surf_def_v(0)%us,  &
-                                                  surf_lsm_v(0)%us, surf_usm_v(0)%us,              &
-                                                  surf_def_v(1)%us, surf_lsm_v(1)%us,              &
-                                                  surf_usm_v(1)%us, surf_def_v(2)%us,              &
-                                                  surf_lsm_v(2)%us, surf_usm_v(2)%us,              &
-                                                  surf_def_v(3)%us, surf_lsm_v(3)%us,              &
-                                                  surf_usm_v(3)%us )
+                CALL surface_data_output_collect(                                  &
+                          surf_def_h(0)%us, surf_lsm_h(0)%us, surf_usm_h(0)%us,    &
+                          surf_def_h(1)%us, surf_lsm_h(1)%us, surf_usm_h(1)%us,    &
+                          surf_def_v(0)%us, surf_lsm_v(0)%us, surf_usm_v(0)%us,    &
+                          surf_def_v(1)%us, surf_lsm_v(1)%us, surf_usm_v(1)%us,    &
+                          surf_def_v(2)%us, surf_lsm_v(2)%us, surf_usm_v(2)%us,    &
+                          surf_def_v(3)%us, surf_lsm_v(3)%us, surf_usm_v(3)%us )
              ELSE
 !
@@ -1548,12 +1542,11 @@
 !--          Output of instantaneous data
              IF ( av == 0 )  THEN
-                CALL surface_data_output_collect( surf_def_h(0)%ts, surf_def_h(1)%ts,              &
-                                                  surf_lsm_h%ts, surf_usm_h%ts, surf_def_v(0)%ts,  &
-                                                  surf_lsm_v(0)%ts, surf_usm_v(0)%ts,              &
-                                                  surf_def_v(1)%ts, surf_lsm_v(1)%ts,              &
-                                                  surf_usm_v(1)%ts, surf_def_v(2)%ts,              &
-                                                  surf_lsm_v(2)%ts, surf_usm_v(2)%ts,              &
-                                                  surf_def_v(3)%ts, surf_lsm_v(3)%ts,              &
-                                                  surf_usm_v(3)%ts )
+                CALL surface_data_output_collect(                                   &
+                          surf_def_h(0)%ts, surf_lsm_h(0)%ts, surf_usm_h(0)%ts,    &
+                          surf_def_h(1)%ts, surf_lsm_h(1)%ts, surf_usm_h(1)%ts,    &
+                          surf_def_v(0)%ts, surf_lsm_v(0)%ts, surf_usm_v(0)%ts,    &
+                          surf_def_v(1)%ts, surf_lsm_v(1)%ts, surf_usm_v(1)%ts,    &
+                          surf_def_v(2)%ts, surf_lsm_v(2)%ts, surf_usm_v(2)%ts,    &
+                          surf_def_v(3)%ts, surf_lsm_v(3)%ts, surf_usm_v(3)%ts )
              ELSE
 !
@@ -1568,12 +1561,11 @@
 !--          Output of instantaneous data
              IF ( av == 0 )  THEN
-                CALL surface_data_output_collect( surf_def_h(0)%qs, surf_def_h(1)%qs,              &
-                                                  surf_lsm_h%qs, surf_usm_h%qs, surf_def_v(0)%qs,  &
-                                                  surf_lsm_v(0)%qs, surf_usm_v(0)%qs,              &
-                                                  surf_def_v(1)%qs, surf_lsm_v(1)%qs,              &
-                                                  surf_usm_v(1)%qs, surf_def_v(2)%qs,              &
-                                                  surf_lsm_v(2)%qs, surf_usm_v(2)%qs,              &
-                                                  surf_def_v(3)%qs, surf_lsm_v(3)%qs,              &
-                                                  surf_usm_v(3)%qs )
+                CALL surface_data_output_collect(                                  &
+                          surf_def_h(0)%qs, surf_lsm_h(0)%qs, surf_usm_h(0)%qs,    &
+                          surf_def_h(1)%qs, surf_lsm_h(1)%qs, surf_usm_h(1)%qs,    &
+                          surf_def_v(0)%qs, surf_lsm_v(0)%qs, surf_usm_v(0)%qs,    &
+                          surf_def_v(1)%qs, surf_lsm_v(1)%qs, surf_usm_v(1)%qs,    &
+                          surf_def_v(2)%qs, surf_lsm_v(2)%qs, surf_usm_v(2)%qs,    &
+                          surf_def_v(3)%qs, surf_lsm_v(3)%qs, surf_usm_v(3)%qs )
              ELSE
 !
@@ -1588,12 +1580,11 @@
 !--          Output of instantaneous data
              IF ( av == 0 )  THEN
-                CALL surface_data_output_collect( surf_def_h(0)%ss, surf_def_h(1)%ss,              &
-                                                  surf_lsm_h%ss, surf_usm_h%ss, surf_def_v(0)%ss,  &
-                                                  surf_lsm_v(0)%ss, surf_usm_v(0)%ss,              &
-                                                  surf_def_v(1)%ss, surf_lsm_v(1)%ss,              &
-                                                  surf_usm_v(1)%ss, surf_def_v(2)%ss,              &
-                                                  surf_lsm_v(2)%ss, surf_usm_v(2)%ss,              &
-                                                  surf_def_v(3)%ss, surf_lsm_v(3)%ss,              &
-                                                  surf_usm_v(3)%ss )
+                CALL surface_data_output_collect(                                  &
+                          surf_def_h(0)%ss, surf_lsm_h(0)%ss, surf_usm_h(0)%ss,    &
+                          surf_def_h(1)%ss, surf_lsm_h(1)%ss, surf_usm_h(1)%ss,    &
+                          surf_def_v(0)%ss, surf_lsm_v(0)%ss, surf_usm_v(0)%ss,    &
+                          surf_def_v(1)%ss, surf_lsm_v(1)%ss, surf_usm_v(1)%ss,    &
+                          surf_def_v(2)%ss, surf_lsm_v(2)%ss, surf_usm_v(2)%ss,    &
+                          surf_def_v(3)%ss, surf_lsm_v(3)%ss, surf_usm_v(3)%ss )
              ELSE
 !
@@ -1608,12 +1599,11 @@
 !--          Output of instantaneous data
              IF ( av == 0 )  THEN
-                CALL surface_data_output_collect( surf_def_h(0)%qcs, surf_def_h(1)%qcs,            &
-                                                  surf_lsm_h%qcs, surf_usm_h%qcs,                  &
-                                                  surf_def_v(0)%qcs, surf_lsm_v(0)%qcs,            &
-                                                  surf_usm_v(0)%qcs, surf_def_v(1)%qcs,            &
-                                                  surf_lsm_v(1)%qcs, surf_usm_v(1)%qcs,            &
-                                                  surf_def_v(2)%qcs, surf_lsm_v(2)%qcs,            &
-                                                  surf_usm_v(2)%qcs, surf_def_v(3)%qcs,            &
-                                                  surf_lsm_v(3)%qcs, surf_usm_v(3)%qcs )
+                CALL surface_data_output_collect(                                     &
+                          surf_def_h(0)%qcs, surf_lsm_h(0)%qcs, surf_usm_h(0)%qcs,    &
+                          surf_def_h(1)%qcs, surf_lsm_h(1)%qcs, surf_usm_h(1)%qcs,    &
+                          surf_def_v(0)%qcs, surf_lsm_v(0)%qcs, surf_usm_v(0)%qcs,    &
+                          surf_def_v(1)%qcs, surf_lsm_v(1)%qcs, surf_usm_v(1)%qcs,    &
+                          surf_def_v(2)%qcs, surf_lsm_v(2)%qcs, surf_usm_v(2)%qcs,    &
+                          surf_def_v(3)%qcs, surf_lsm_v(3)%qcs, surf_usm_v(3)%qcs )
              ELSE
 !
@@ -1628,12 +1618,11 @@
 !--          Output of instantaneous data
              IF ( av == 0 )  THEN
-                CALL surface_data_output_collect( surf_def_h(0)%ncs, surf_def_h(1)%ncs,            &
-                                                 surf_lsm_h%ncs, surf_usm_h%ncs,                   &
-                                                 surf_def_v(0)%ncs, surf_lsm_v(0)%ncs,             &
-                                                 surf_usm_v(0)%ncs, surf_def_v(1)%ncs,             &
-                                                 surf_lsm_v(1)%ncs, surf_usm_v(1)%ncs,             &
-                                                 surf_def_v(2)%ncs, surf_lsm_v(2)%ncs,             &
-                                                 surf_usm_v(2)%ncs, surf_def_v(3)%ncs,             &
-                                                 surf_lsm_v(3)%ncs, surf_usm_v(3)%ncs )
+                CALL surface_data_output_collect(                                     &
+                          surf_def_h(0)%ncs, surf_lsm_h(0)%ncs, surf_usm_h(0)%ncs,    &
+                          surf_def_h(1)%ncs, surf_lsm_h(1)%ncs, surf_usm_h(1)%ncs,    &
+                          surf_def_v(0)%ncs, surf_lsm_v(0)%ncs, surf_usm_v(0)%ncs,    &
+                          surf_def_v(1)%ncs, surf_lsm_v(1)%ncs, surf_usm_v(1)%ncs,    &
+                          surf_def_v(2)%ncs, surf_lsm_v(2)%ncs, surf_usm_v(2)%ncs,    &
+                          surf_def_v(3)%ncs, surf_lsm_v(3)%ncs, surf_usm_v(3)%ncs )
              ELSE
 !
@@ -1648,12 +1637,11 @@
 !--          Output of instantaneous data
              IF ( av == 0 )  THEN
-                CALL surface_data_output_collect( surf_def_h(0)%qis, surf_def_h(1)%qis,            &
-                                                  surf_lsm_h%qis, surf_usm_h%qis,                  &
-                                                  surf_def_v(0)%qis, surf_lsm_v(0)%qis,            &
-                                                  surf_usm_v(0)%qis, surf_def_v(1)%qis,            &
-                                                  surf_lsm_v(1)%qis, surf_usm_v(1)%qis,            &
-                                                  surf_def_v(2)%qis, surf_lsm_v(2)%qis,            &
-                                                  surf_usm_v(2)%qis, surf_def_v(3)%qis,            &
-                                                  surf_lsm_v(3)%qis, surf_usm_v(3)%qis )
+                CALL surface_data_output_collect(                                     &
+                          surf_def_h(0)%qis, surf_lsm_h(0)%qis, surf_usm_h(0)%qis,    &
+                          surf_def_h(1)%qis, surf_lsm_h(1)%qis, surf_usm_h(1)%qis,    &
+                          surf_def_v(0)%qis, surf_lsm_v(0)%qis, surf_usm_v(0)%qis,    &
+                          surf_def_v(1)%qis, surf_lsm_v(1)%qis, surf_usm_v(1)%qis,    &
+                          surf_def_v(2)%qis, surf_lsm_v(2)%qis, surf_usm_v(2)%qis,    &
+                          surf_def_v(3)%qis, surf_lsm_v(3)%qis, surf_usm_v(3)%qis )
              ELSE
 !
@@ -1668,12 +1656,11 @@
 !--          Output of instantaneous data
              IF ( av == 0 )  THEN
-                CALL surface_data_output_collect( surf_def_h(0)%nis, surf_def_h(1)%nis,            &
-                                                  surf_lsm_h%nis, surf_usm_h%nis,                  &
-                                                  surf_def_v(0)%nis, surf_lsm_v(0)%nis,            &
-                                                  surf_usm_v(0)%nis, surf_def_v(1)%nis,            &
-                                                  surf_lsm_v(1)%nis, surf_usm_v(1)%nis,            &
-                                                  surf_def_v(2)%nis, surf_lsm_v(2)%nis,            &
-                                                  surf_usm_v(2)%nis, surf_def_v(3)%nis,            &
-                                                  surf_lsm_v(3)%nis, surf_usm_v(3)%nis )
+                CALL surface_data_output_collect(                                     &
+                          surf_def_h(0)%nis, surf_lsm_h(0)%nis, surf_usm_h(0)%nis,    &
+                          surf_def_h(1)%nis, surf_lsm_h(1)%nis, surf_usm_h(1)%nis,    &
+                          surf_def_v(0)%nis, surf_lsm_v(0)%nis, surf_usm_v(0)%nis,    &
+                          surf_def_v(1)%nis, surf_lsm_v(1)%nis, surf_usm_v(1)%nis,    &
+                          surf_def_v(2)%nis, surf_lsm_v(2)%nis, surf_usm_v(2)%nis,    &
+                          surf_def_v(3)%nis, surf_lsm_v(3)%nis, surf_usm_v(3)%nis )
              ELSE
 !
